<?php
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgUserJcsmember extends JPlugin {

	function plgUserJcsmember(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}
	function onBeforeStoreUser($user, $isnew)
	{
		global $mainframe;
	}
	function onAfterStoreUser($user, $isnew, $succes, $msg)
	{
		global $mainframe;
		if($mainframe->isAdmin()) return;
		//grant to only new users who just register, if not than goodbye!
		if(!$isnew) return;
		jimport('joomla.application.component.model');
		JModel::addIncludePath(JPATH_ROOT.DS."components".DS."com_jcs".DS."models");
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS."components".DS."com_jcs".DS.'tables');
		$model = JModel::getInstance('jcs','JcsModel');

		$db =& JFactory::getDBO();
		//new user
		$sql = "SELECT p.id as pid , p.price as price , p.granturl, p.params
			FROM #__jcs_plans as p 
			WHERE p.grant_new AND p.published = '1'";
		$db->setQuery($sql);
		$subcription_user = false;
		if($plans = $db->loadObjectList())
		{
			foreach ($plans as $plan)
			{
				$params = new JParameter($plan->params);
				if($purchase_limit = $params->get('purchase_limit'))
				{
					$subscr = $model->getActiveSubscriptions($plan->pid);
					settype($purchase_limit, 'int');
					if( ($purchase_limit - $subscr) <= 0)
					continue;
				}
				$out['sid'] = $plan->pid;
				$out['gateway'] = '.grant_new';
				$out['gateway_id'] = (time() + @$i++);
				$out['user_id'] = $user['id'];
				$out['price'] = '0.00';
				$out['pay'] = 'success';
				// new users who just registered could not have any subsriptions so commented this code delete later
//				$sql = "SELECT subscription_id, user_id FROM #__jcs_user_subscr
//				    WHERE user_id = ".$user['id']." AND subscription_id = ".$plan->pid;
//				$db->setQuery($sql);
//				$result = $db->loadObjectList();
//				if(count($result) <= 0)
//				{
//					$model->store($out);
//					$subcription_user = true;
//					$granturl = $plan->granturl;
//				}

				//we'll save subsriptions in db only if user saved successfully
				if($succes)
				{
					$model->store($out);
					$subcription_user = true;
					$granturl = $plan->granturl;
				}
			}
		}
		if($subcription_user){
			$msg = JText::_( 'You have been granted a subscription successfully' );
			if(!$granturl){
				$link = 'index.php?option=com_jcs&view=jcs&layout=history&Itemid='.JRequest::getInt('Itemid');
			}else {
				//@note if it will be several grant subsriptions and they will have different grant urls than user will be redirected to the last one catched in cycle above
				$link = 'index.php?option=com_content&view=article&id='.$granturl.'&Itemid='.JRequest::getInt('Itemid');
			}
			$mainframe->enqueueMessage($msg);
			// if($link) $mainframe->redirect($link);
		}
	}
	function onBeforeDeleteUser($user)
	{
	}

	function onAfterDeleteUser($user, $succes, $msg)
	{

	}

	function onLoginUser($user, $options)
	{

		global $mainframe;
		if($mainframe->isAdmin()){
			return true;
		}
		jimport('joomla.application.component.model');
		JModel::addIncludePath(JPATH_ROOT.DS."components".DS."com_jcs".DS."models");
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS."components".DS."com_jcs".DS.'tables');
		$model = JModel::getInstance('jcs','JcsModel');

		$db =& JFactory::getDBO();

		//old user
		$sql = "SELECT p.grant_reg, p.id as pid , p.price as price, p.granturl as granturl, p.params, u.id as uid
        	FROM #__jcs_plans as p, #__users AS u
        	WHERE p.grant_reg and p.ctime > u.registerDate AND u.username = '".$user['username']."'
        	AND p.published = '1'";

		$db->setQuery($sql);
		$plans = $db->loadObjectList();
		$subcription_user = false;
		if(count($plans) > 0)
		{
			$_i = 1;

			foreach ($plans as $plan)
			{
				$params = new JParameter($plan->params);
				if($purchase_limit = $params->get('purchase_limit'))
				{
					$subscr = $model->getActiveSubscriptions($plan->pid);
					settype($purchase_limit, 'int');
					if( ($purchase_limit - $subscr) <= 0)
					continue;
				}
				
				$out['sid'] = $plan->pid;
				$out['gateway'] = '.grant_registered';
				$out['gateway_id'] = time()+$_i;
				$out['user_id'] = $plan->uid;
				$out['price'] = '0.00';
				$out['pay'] = 'success';
					
				$_i++;

				$sql = "SELECT subscription_id, user_id
			    FROM #__jcs_user_subscr 
			    WHERE user_id = ".$plan->uid." AND subscription_id = ".$plan->pid." 
			    AND published = 1";
					
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				if(count($result) <= 0) {
					if ($model->store($out)) {
						$subcription_user = true;
						$granturl = $plan->granturl;
					}
				}
					
			}
		}

		if($subcription_user){
			$msg = JText::_( 'You have been granted a subscription successfully' );

			if(!$granturl){
				$link = 'index.php?option=com_jcs&view=jcs&layout=history&Itemid='.JRequest::getInt('Itemid');
			}else {
				$link = 'index.php?option=com_content&view=article&id='.$granturl.'&Itemid='.JRequest::getInt('Itemid');
			}

			$mainframe->enqueueMessage($msg);
			if($link) $mainframe->redirect($link);

		}

	}

	function onLogoutUser($user)
	{

	}
}